#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Aug 28 16:19:02 2021

"""

from sys import exit

# Presenta all'utente la descrizione del programma.
frase1 = "Questo programma effettua conversioni dal sistema americano al SI e viceversa.\n\n" 
frase2 = "Le unità di misura che si possono inserire sono le seguenti.\n"
frase3 = "Per il sistema americano:\n"
frase4 = " - once liquide (fl oz), pinte (pt), quarti (qt) o galloni (gal)\n"
frase5 = " - grani (gr), dramme (dr), once (oz), libbre (lb), quintali (ctw)\n"
frase6 = "   o tonnellate (ton)\n"
frase7 = " - pollici (in), piedi (ft), iarde (yd) o miglia (mi);\n"
frase8 = "per il Sistema Interazionale:\n"
frase9 = " - millilitri (ml), centilitri (cl) o litri (l);\n"
frase10 = " - milligrammi (mg), grammi (g), chilogrammi (kg);\n"
frase11 = " - millimetri (mm), centimetri (cm), metri (m) o chilometri (km)."

messaggio = (frase1 + frase2 + frase3 + frase4 + frase5 + frase6 + frase7 + 
             frase8 + frase9 + frase10 + frase11)
print("\n" + messaggio)

# Definisce le costanti 
# Sistema americano in SI.
FL_OZ = 0.03 # litri = oncia liquida
PT = 0.473176473 # litri = inta
QT = 0.946352946 # litri = quarto
GAL = 3.84 # litri = gallone

GR = 64.79891 * 1E-6 # chilogrammi = grano
DR = 1,7718451953125 * 1E-3 # chilogrammi = dramma
OZ = 0.02835 # chilogrammi = oncia
LB = 0.45359 # chilogrammi = libbra
CWT = 45.359237 # chilogrammi (100lb) = quintale americano
TON = 907.18474 # chilogrammi (2000lb) = tonnellata

IN = 25.4 * 1E-6 # chilometri = pollice
FT = 0,3048 * 1E-3 # chilometri = piede
YD = 0,9144 * 1E-3 # chilometri = iarda
MI = 1.60934 # chilometri = miglio

# SI in Sistema americano.
ML = 0.264172 * 1E-3 # galloni
CL = 0.264172 * 1E-2 # galloni
L = 0.264172 # galloni

MG = 1.10231131 * 1E-9 # tonnellate
G = 1.10231131 * 1E-6 # tonnellate
KG = 1.10231131 * 1E-3 # tonnellate

MM = 0.62137273665 * 1E-6 # miglia
CM = 0.62137273665 * 1E-5 # miglia
M = 0.62137273665 * 1E-3 # miglia
KM = 0.62137273665 # miglia

# Acquisisce dall'utente l'unità di misura che si vuole convertire e seleziona 
# un primo fattore di conversione.
fattoreConversione = float()

unitàPartenza = input("Inserire l'unità di misura da cui si vuole effettuare la conversione: ")

# Unità di partenza americane (prima) e del SI (poi).
if unitàPartenza == "fl oz" :
    fattoreConversione = FL_OZ
elif unitàPartenza == "pt" :
    fattoreConversione = PT
elif unitàPartenza == "qt" :
    fattoreConversione = QT
elif unitàPartenza == "gal" :
    fattoreConversione = GAL
elif unitàPartenza == "gr" :
    fattoreConversione = GR
elif unitàPartenza == "dr" :
    fattoreConversione = DR
elif unitàPartenza == "oz" :
    fattoreConversione = OZ
elif unitàPartenza == "lb" :
    fattoreConversione = LB
elif unitàPartenza == "ctw" :
    fattoreConversione = CWT
elif unitàPartenza == "ton" :
    fattoreConversione = TON
elif unitàPartenza == "in" :
    fattoreConversione = IN
elif unitàPartenza == "ft" :
    fattoreConversione = FT
elif unitàPartenza == "yd" :
    fattoreConversione = YD
elif unitàPartenza == "mi" :
    fattoreConversione = MI
elif unitàPartenza == "ml" :
    fattoreConversione = ML
elif unitàPartenza == "cl" :
    fattoreConversione = CL
elif unitàPartenza == "l" :
    fattoreConversione = L
elif unitàPartenza == "mg" :
    fattoreConversione = MG
elif unitàPartenza == "g" :
    fattoreConversione = G
elif unitàPartenza == "kg" :
    fattoreConversione = KG
elif unitàPartenza == "mm" :
    fattoreConversione = MM
elif unitàPartenza == "cm" :
    fattoreConversione = CM
elif unitàPartenza == "m" :
    fattoreConversione = M
elif unitàPartenza == "km" :
    fattoreConversione = KM    
else :
    exit("Errore: unità di partenza non valida.")
    
# Acquisisce l'unità di arrivo e appronta il fattore di conversione.
frase = "Errore: conversione impossibile o unità di arrivo non valida."

unitàArrivo = input("Inserire l'unità di misura a cui si vuole convertire: ")
if (unitàPartenza == "fl oz" or unitàPartenza == "pt" or unitàPartenza == "qt" 
    or unitàPartenza == "gal") :
    if unitàArrivo == "ml" :
        fattoreConversione *= 1E3
    elif unitàArrivo == "cl" :
        fattoreConversione *= 1E2
    elif unitàArrivo != "l" :
        exit(frase)
elif (unitàPartenza == "gr" or unitàPartenza == "dr" or unitàPartenza == "oz" 
      or unitàPartenza == "lb" or unitàPartenza == "ctw" or unitàPartenza == "ton") :
    if unitàArrivo == "mg" :
        fattoreConversione *= 1E6
    elif unitàArrivo == "g" :
        fattoreConversione *= 1E3
    elif unitàArrivo != "kg" :
        exit(frase)
elif (unitàPartenza == "in" or unitàPartenza == "ft" or unitàPartenza == "yd" 
      or unitàPartenza == "mi") :
    if unitàArrivo == "mm" :
        fattoreConversione *= 1E6
    elif unitàArrivo == "cm" :
        fattoreConversione *= 1E5
    elif unitàArrivo == "m" :
        fattoreConversione *= 1E3
    elif unitàArrivo != "km" :
         exit(frase)
elif unitàPartenza == "ml" or unitàPartenza == "cl" or unitàPartenza == "l" :
    if unitàArrivo == "fl oz" :
        fattoreConversione *= 128 
    elif unitàArrivo == "pt" :
        fattoreConversione  *= 8
    elif unitàArrivo == "qt" :
        fattoreConversione *= 4
    elif unitàArrivo != "gal" :
        exit(frase)
elif unitàPartenza == "mg" or unitàPartenza == "g" or unitàPartenza == "kg" :
    if unitàArrivo == "gr" :
        fattoreConversione *= 14 * 1E6
    elif unitàArrivo == "dr" :
        fattoreConversione *= 1.50841750842 * 1E6
    elif unitàArrivo == "oz" :
        fattoreConversione *= 0.09427609427 * 1E6
    elif unitàArrivo == "lb" :
        fattoreConversione *= 2000
    elif unitàArrivo == "ctw" :
        fattoreConversione *= 20
    elif unitàArrivo != "ton" :
        exit (frase)
elif (unitàPartenza == "mm" or unitàPartenza == "cm" or unitàPartenza == "m" or
      unitàPartenza == "km") :
    if unitàArrivo == "in" :
        fattoreConversione *= 63360
    elif unitàArrivo == "ft" :
        fattoreConversione *= 5280
    elif unitàArrivo == "yd" :
        fattoreConversione *= 1760
    elif unitàArrivo != "mi" :
        exit(frase)

# Acquisisce il valore ed effettua la conversione.
valorePartenza = float(input("Inserire il valore che si vuole convertire: "))
valoreArrivo = valorePartenza * fattoreConversione

# Visualizza il risultato.
print()
print("Conversione: %.3f %s equivalgono a %.3f %s." % 
      (valorePartenza, unitàPartenza, valoreArrivo, unitàArrivo))
print("-" * 50)

    
